set long 4096
set echo on
set pagesize 100
set linesize 100
set serveroutput on
clear scr
pause Welcome to New Features in Oracle 11g PL/SQL
--
pause PL/SQL RESULT_CACHE
@result_cache_off
@result_cache_on
@resultcacheplsql1
--
--
set serveroutput on
pause COMPOUND TRIGGER
DROP TRIGGER EMPCOMPOUND;
DROP TRIGGER EMPCOMPOUND2;
DROP TRIGGER EMP_FOLLOWS1;
DROP TRIGGER EMP_FOLLOWS2;
@empcompound
UPDATE emp SET SAL = 4000.01 WHERE ENAME = 'KING';
rollback;
--
pause MORE COMPOUND TRIGGER
@emp_follows1
@emp_follows2
@empcompound2
UPDATE emp SET SAL = 4000.01 WHERE ENAME = 'KING';
rollback;
--
pause SIMPLE_INTEGER
declare
--  mytestvar pls_integer := 2147483645;
  mytestvar simple_integer := 2147483645;
begin
  dbms_output.put_line('Value of mytestvar starting ' || mytestvar);
  loop
     mytestvar := mytestvar + 1;
     dbms_output.put_line('Value of mytestvar is now ' || mytestvar);
     exit when mytestvar < 10;
  end loop;
  dbms_output.put_line('Value of mytestvar at end is ' || mytestvar);
end;
/
pause PLS_INTEGER
declare
  mytestvar pls_integer := 2147483645;
--  mytestvar simple_integer := 2147483645;
begin
  dbms_output.put_line('Value of mytestvar starting ' || mytestvar);
  loop
     mytestvar := mytestvar + 1;
     dbms_output.put_line('Value of mytestvar is now ' || mytestvar);
     exit when mytestvar < 10;
  end loop;
  dbms_output.put_line('Value of mytestvar at end is ' || mytestvar);
end;
/
pause PL/SQL SEQUENCE
--
drop sequence ora11seq;
--
create sequence ora11seq
  start with 10 increment by 2;
--
declare
   myvalue pls_integer := 0;
begin
   dbms_output.put_line('Starting now...');
   for loopctr in 1..5 loop
       myvalue := ora11seq.nextval;
   end loop;
   dbms_output.put_line('Value of myvalue is ' || to_char(myvalue));
end;
/
pause PL/SQL CONTINUE
declare
   ctr pls_integer := 6;
begin
   dbms_output.put_line('Counting down to blastoff!');
   for loopctr in reverse 1 .. ctr loop
     if loopctr in (4,2) then
         continue;
     end if;
     dbms_output.put_line(to_char(loopctr));
   end loop;
   dbms_output.put_line('Blast Off!');
end;
/
pause REGEXP_COUNT
-- Counts occurrences 
--    of letter 'L'
--    starting in position 1
--    in a case-insenstive way 
select ename
      ,regexp_count(ename,'l',1,'i') EnameO 
   from emp;
pause PL/SQL FUNCTION CALL
CREATE OR REPLACE FUNCTION TEST_CALL
  ( inval1 IN NUMBER
  , inval2 IN NUMBER
  , inval3 IN NUMBER
  ) RETURN NUMBER AS
BEGIN
  RETURN inval1 + inval2 + inval3;
END TEST_CALL;
/
declare
  vara number := 23;
  varb number := 34;
  varc number := 45;
begin
  dbms_output.put_line('Pos  ' || test_call(vara,varb,varc));
  dbms_output.put_line('Name ' || test_call(inval3=>varc,inval1=>vara,inval2=>varb));
  dbms_output.put_line('Mix  ' || test_call(vara,inval3=>varc,inval2=>varb));
end;
/
pause ALL DONE...